(function() {
  var scc_products_after_checked, scc_products_after_unchecked;

  scc_products_after_checked = function(target) {
    var parent;
    if (target.parentNode.dataset.parent) {
      parent = $("#" + target.parentNode.dataset.parent + " input")[0];
      if (!parent.checked && !parent.disabled) {
        parent.checked = true;
        return scc_products_after_checked(parent);
      }
    }
  };

  scc_products_after_unchecked = function(target) {
    return $("span.scc_product_checkbox input", target.parentNode.parentNode).each(function(index, child) {
      if (child.checked && !child.disabled) {
        child.checked = false;
        return scc_products_after_unchecked(child);
      }
    });
  };

  $(function() {
    $("body").on("change", "span.scc_product_checkbox input", function(event) {
      var target;
      target = event.target;
      if (target.checked) {
        return scc_products_after_checked(target);
      } else {
        return scc_products_after_unchecked(target);
      }
    });
    $("body").on("click", "a.edit_deferrer", function(event) {
      event.preventDefault();
      return $("a.edit_deferree", $(event.target).closest("tr"))[0].click();
    });
    return $("body").on("click", "#test_scc_connection_btn", function(event) {
      $('.tab-error').removeClass('tab-error');
      $('#connection_test_result')[0].innerHTML = '';
      $('#test_scc_connection_indicator').show();
      return $.ajax(event.target.parentNode.dataset['url'], {
        type: 'PUT',
        dataType: 'JSON',
        data: $('form').serialize(),
        success: function(result) {
          $('#test_scc_connection_btn').addClass('btn-success');
          $('#test_scc_connection_btn').removeClass('btn-default');
          return $('#test_scc_connection_btn').removeClass('btn-danger');
        },
        error: function(result) {
          $('#test_scc_connection_btn').addClass('btn-danger');
          $('#test_scc_connection_btn').removeClass('btn-default');
          $('#test_scc_connection_btn').removeClass('btn-success');
          $('#scc_account_login').closest('.form-group').addClass('tab-error');
          $('#scc_account_password').closest('.form-group').addClass('tab-error');
          $('#scc_account_base_url').closest('.form-group').addClass('tab-error');
          $('#connection_test_result')[0].innerHTML = 'Connection test failed!';
          return $('#scc_account_login').focus();
        },
        complete: function(result) {
          return $('#test_scc_connection_indicator').hide();
        }
      });
    });
  });

}).call(this);
